/*   Copyright (c) J. Ali Harlow 2000                               */
/*   NetHack may be freely redistributed.  See license for details. */

/*
 * Filter a text file file by removing any tiles which have, or appear
 * to have been magnified from a lower resolution.
 */

#include "config.h"
#include "tile.h"

static boolean
low_res_tile(bitmap)
pixel (*bitmap)[MAX_TILE_X];
{
    int x, y;

    for(y = 0; y < tile_y - 1; y += 2)
	if (memcmp(bitmap[y], bitmap[y + 1], sizeof(*bitmap)))
	    return FALSE;

    for(x = 0; x < tile_x - 1; x += 2)
	for(y = 0; y < tile_y; y++)
	    if (memcmp(&bitmap[y][x],&bitmap[y][x + 1],sizeof(bitmap[y][x])))
		return FALSE;

    return TRUE;
}

int
main(argc, argv)
int argc;
char **argv;
{
    char ttype[BUFSZ];
    int number;
    char name[BUFSZ];
    pixel pixels[MAX_TILE_Y][MAX_TILE_X];

    if (argc != 3) {
	Fprintf(stderr, "usage: txtfilt infile outfile\n");
	exit(EXIT_FAILURE);
    }

    if (!fopen_text_file(argv[1], RDTMODE))
	exit(EXIT_FAILURE);
    if (!fopen_text_file(argv[2], WRTMODE))
	exit(EXIT_FAILURE);

    while (read_text_tile_info(pixels, ttype, &number, name)) {
	if (!low_res_tile(pixels))
	    write_text_tile_info(pixels, ttype, number, name);
    }
    fclose_text_file();

    exit(EXIT_SUCCESS);
    /*NOTREACHED*/
    return 0;
}
